GRATgen: Global_Data Class Reference

GRATgen

Public Member Functions | Related Functions | List of all members
Global_Data Class Reference

Global data, which is constant after forward pass. More...

Collaboration diagram for Global_Data:
[legend]

## Public Member Functions
| Global_Data ()
| Standard constructor.
ClauseDB & | get_db ()
| Get associated clause database.
size_t | get_max_var () const
| Get maximum number of variables.
size_t | get_num_clauses () const
| Get number of clauses.
bool | is_after_parsing () const
| Check whether we are in after-parsing phase.
lit_t | get_pivot (lit_t *cl) const
| Get the pivot literal associated to a clause. Empty clauses have pivot 0.
size_t | get_fst_prf_item () const
| Get the first item of the DRAT certificate.
size_t | get_num_items () const
| Get the total number of items.
void | truncate_items (size_t _num_items)
| Truncate items, discarding the tail. More...
item_t & | get_item (size_t i)
| Get item by index.
size_t | get_fst_lemma_id () const
| Get the id for the first lemma, i.e., the id of the last clause + 1.
bool | is_formula_clause (lit_t *cl) const
| Check if this clause belongs to the original formula (true), or the proof (false)
bool | is_formula_clause (size_t id) const
| Check if this clause id belongs to the original formula (true), or the proof (false)
void | init_after_fwd (pos_t cn_pos, vector< trail_item_t > const &tr)
| Initialization after forward pass: More...
void | join_vmarked (vector< bool > const &marked)
| Join marking information for forward trail with provided information. More...
const vector< pair< size_t, bool > > & | get_fwd_trail () const
| Return the forward trail, with marking information joined in.
lit_t * | get_conflict ()
| Return the conflict clause.

## Related Functions
(Note that these are not member functions.)
Global_Data | glb
| Only instance of Global_Data.

## Detailed Description

Global data, which is constant after forward pass.

## Member Function Documentation

## ◆ init_after_fwd()

void Global_Data::init_after_fwd | ( | pos_t | cn_pos,
|  | vector< trail_item_t > const & | tr
| ) |  |

Initialization after forward pass:

Parameters

  cn_pos | Position of conflict clause
  tr | Trail after forward pass

See also
  Object_Lifetimes

## ◆ join_vmarked()

void Global_Data::join_vmarked | ( | vector< bool > const & | marked | ) |

Join marking information for forward trail with provided information.

This is used after the concurrent backwards phase to join the information computed by the different threads.

## ◆ truncate_items()

void Global_Data::truncate_items | ( | size_t | _num_items | ) |

Truncate items, discarding the tail.

Precondition
  New number of items must be less or equal to current number of items.

The documentation for this class was generated from the following file:

- gratgen.cpp